Strict

Framework BRL.Blitz
  
' cloud scene node demo by Gaz Davidson - gaz@bitplane.net

Import gg.IrrBMAX
Import gg.IrrAddons

Local node:T_irrISceneNode
Local device:T_irrIrrlichtDevice

' create the device, as usual

device = T_irrIrrlichtDevice.create(EDT_OPENGL,T_irrDimension2d_s32.create(800, 600),16,False,False,False)

Local driver:T_irrIVideoDriver=device.getVideoDriver()
Local smgr:T_irrISceneManager=device.getSceneManager()

Local tex:T_irrITexture = driver.getTexture("data/blue.bmp")
Local lineColor:T_irrSColor=T_irrSColor.createFromVals(255,200,250,200)
Local bbSize:T_irrDimension2d_f32=T_irrDimension2d_f32.create(20,20)

Local aNode:T_irrIAnimatedMeshSceneNode = smgr.addAnimatedMeshSceneNode(smgr.getMesh("data/sabre.3ds"))
aNode.setMaterialTexture(0,driver.getTexture("data/sabre.bmp"))

Local sNode:T_irrISceneNode = ..
	T_irrSizzlerSceneNode.createSizzlerSceneNode(aNode,smgr,-1, ..
	T_irrVector3df.createFromVals(0,40,0), ..
	T_irrVector3df.createFromVals(0,490,0), ..
	50,10.0,25,lineColor,tex,bbSize).getISceneNode()

Local anim:T_irrISceneNodeAnimator = smgr.createRotationAnimator(T_irrVector3df.createFromVals(0.5,0.4,0.5))
aNode.addAnimator(anim)

anim.drop()
sNode.drop()

' now lets add a camera...
Local camera:T_irrICameraSceneNode = smgr.addCameraSceneNodeFPS()
camera.setPosition(T_irrVector3df.createFromVals(0,50,-300))
  
' turn off the cursor
device.getCursorControl().setVisible(False)
 
Local lastFPS:Int = -1

Local font1:T_irrIGUIFont = device.getGUIEnvironment().getFont("data/font.tga")
Local font:T_irrIGUIFont
If font1.IsValid() Then font=font1 Else font=device.getGUIEnvironment().getBuiltInFont()

While(device.run()) 
	driver.beginScene(True, True, T_irrSColor.createFromVals(255,153,153,253))
	smgr.drawAll()    

	device.getGUIEnvironment().drawAll()

	font.draw("Light Sabre Demo using IrrSizzler Scene Node",T_irrRect_s32.createFromVals(10,10,200,25),T_irrSColor.createFromVals(255,200,200,200))
	font.draw("by Saurav Mohapatra (log1is0@gmail.com)",T_irrRect_s32.createFromVals(10,30,200,45),T_irrSColor.createFromVals(255,200,200,200))
	font.draw("Use Mouse and Arrow Keys to move",T_irrRect_s32.createFromVals(10,50,200,65),T_irrSColor.createFromVals(255,200,200,200))
	font.draw("Source Code and Demo Available at M_TRIX Website (Coming Soon)",T_irrRect_s32.createFromVals(10,70,200,85),T_irrSColor.createFromVals(255,200,200,200))
	font.draw("WEBSITE : http://www.geocities.com/standard_template/index.html",T_irrRect_s32.createFromVals(10,90,200,105),T_irrSColor.createFromVals(255,200,200,200))

	driver.endScene()

	Local fps:Int = driver.getFPS()
    
	If (lastFPS <> fps) Then
		Local str:String = "IrrSizzler Scene Node - Irrlicht Engine ["
		str :+ driver.getName()
		str :+ "] FPS:"
		str :+ fps

		device.setWindowCaption(str)
		lastFPS = fps
	EndIf	
Wend

' In the End, Delete the Irrlicht device.
device.drop()

